<html lang="en">
<head>
<title>Customizing - Enhanced Implementation of Emacs Interpreted Objects</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Enhanced Implementation of Emacs Interpreted Objects">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="Class-Values.html#Class-Values" title="Class Values">
<link rel="next" href="Documentation.html#Documentation" title="Documentation">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Customizing"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Documentation.html#Documentation">Documentation</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Class-Values.html#Class-Values">Class Values</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name, next, previous, up -->
<h2 class="chapter">15 Customizing Objects</h2>

<p>In Emacs 20 a useful customization utility became available called
`custom'.  EIEIO supports custom through two new widget types.  If a
variable is declared as type <code>'object</code>, then full editing of slots
via the widgets is made possible.  This should be used carefully,
however, because objects modified are cloned, so if there are other
references to these objects, they will no longer be linked together.

   <p>If you want in place editing of objects, use the following methods:

<div class="defun">
&mdash; Function: <b>eieio-customize-object</b><var> object<a name="index-eieio_002dcustomize_002dobject-86"></a></var><br>
<blockquote><p>Create a custom buffer and insert a widget for editing <var>object</var>.  At
the end, an <code>Apply</code> and <code>Reset</code> button are available.  This
will edit the object "in place" so references to it are also changed. 
There is no effort to prevent multiple edits of a singular object, so
care must be taken by the user of this function. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>eieio-custom-widget-insert</b><var> object flags<a name="index-eieio_002dcustom_002dwidget_002dinsert-87"></a></var><br>
<blockquote><p>This method inserts an edit object into the current buffer in place. 
It's sole code is <code>(widget-create 'object-edit :value object)</code> and
is provided as a locale for adding tracking, or specializing the widget
insert procedure for any object. 
</p></blockquote></div>

   <p>To define a slot with an object in it, use the <code>object</code> tag.  This
widget type will be automatically converted to <code>object-edit</code> if you
do in place editing of you object.

   <p>If you want to have additional actions taken when a user clicks on the
<code>Apply</code> button, then overload the method <code>eieio-done-customizing</code>. 
This method does nothing by default, but that may change in the future. 
This would be the best way to make your objects persistent when using
in-place editing.

<h3 class="section">15.1 Widget extention</h3>

<p>When widgets are being created, one new widget extention has been added,
called the <code>:slotofchoices</code>.  When this occurs in a widget
definition, all elements after it are removed, and the slot is specifies
is queried and converted into a series of constants.

<pre class="example">     (choice (const :tag "None" nil)
             :slotofchoices morestuff)
</pre>
   <p>and if the slot <code>morestuff</code> contains <code>(sym1 sym2 sym3)</code>, the
above example is converted into:

<pre class="example">     (choice (const :tag "None" nil)
             (const sym1)
             (const sym2)
             (const sym3))
</pre>
   <p>This is useful when a given item needs to be selected from a list of
items defined in this second slot.

   </body></html>

